from CvPythonExtensions import *
import CvUtil
import CvScreensInterface
import CvDebugTools
import CvWBPopups
import PyHelpers
import Popup as PyPopup
import CvCameraControls
import CvTopCivs
import sys
import CvWorldBuilderScreen
import CvAdvisorUtils
import CvTechChooser
import CvEventManager

import Recon
re = Recon.recon()

gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo

# globals
###################################################
class CvReconquistaEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)

	def onGameStart(self, argsList):
		'Called at the start of the game'
		self.parent.onGameStart(self, argsList)
		re.gamestart()

	def onUnitMove(self, argsList):
		'unit move'
		self.parent.onUnitMove(self, argsList)
		pPlot,pUnit = argsList
		player = PyPlayer(pUnit.getOwner())
		unitInfo = PyInfo.UnitInfo(pUnit.getUnitType())
		re.checkunitmove(pUnit)

	def onCityAcquired(self, argsList):
		'City Acquired'
		self.parent.onCityAcquired(self, argsList)
		owner,playerType,city,bConquest,bTrade = argsList
		
		if bConquest:
			re.cityconquest(owner, city, playerType)

	def onBeginGameTurn(self, argsList):
		'Called at the beginning of a players turn'
		self.parent.onBeginGameTurn(self, argsList)
		iGameTurn = argsList[0]
		re.begingameturn(iGameTurn)

	def onBeginPlayerTurn(self, argsList):
		'Called at the beginning of a players turn'
		self.parent.onBeginPlayerTurn(self, argsList)
		iGameTurn, iPlayer = argsList
		re.beginplayerturn(iGameTurn, iPlayer)

	def onTechAcquired(self, argsList):
		'Tech Acquired'
		self.parent.onTechAcquired(self, argsList)
		iTechType, iTeam, iPlayer, bAnnounce = argsList
		re.tech(iTechType, iTeam, iPlayer, bAnnounce)

