from CvPythonExtensions import *
import CvUtil
import CvCameraControls
import CvTranslator
import PyHelpers
import Popup as PyPopup
import pickle

gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
localText = CyTranslator()

# teams
iAlmohad = 0
iAragon = 1
iCastille = 2
iFrance = 3
iLeon = 4
iNavarre = 5
iPortugal = 6

tAllTeams = (iAlmohad, iAragon, iCastille, iFrance, iLeon, iNavarre, iPortugal)

# units
iMilitia = 10
iSwordsman = 11
iAxeman = 12
iMaceman = 13
iPikeman = 14
iArcher = 17
iSkirmisher = 18
iCrossbowman = 20
iArabHorse = 21
iChristianHorse = 22
iCamelArcher = 23
iConquistador = 24

# buildings
iChristianMonastery = 25

# techs
iTechTaifaKingdoms = 2
iTechCrusades = 6

# cities
tFez = (34, 4)
tTlemcen = (41, 18)
tTangier = (27, 7)
tBougie = (51, 38)
tAlgiers = (48, 33)
tOran = (40, 23)
tMelilla = (35, 12)
tBiskra = (52, 30)
tRibat = (29, 2)
tTahert = (46, 27)
tLagos = (17, 7)
tCadiz = (23, 9)
tBadajoz = (17, 13)
tSevilla = (21, 12)
tCordoba = (23, 17)
tGranada = (28, 19)
tMalaga = (26, 12)
tMurcia = (29, 26)
tCartagena = (31, 23)
tValencia = (28, 31)
tPalma = (36, 37)
tBarcelona = (28, 40)
tTortosa = (28, 36)
tZaragossa = (22, 34)
tLerida = (24, 38)
tBurgos = (14, 31)
tValladolid = (16, 27)
tSantander = (10, 32)
tSoria = (18, 30)
tToledo = (20, 22)
tMadrid = (20, 25)
tSalamanca = (15, 20)
tBayonne = (16, 40)
tPau = (20, 40)
tLeon = (9, 26)
tZamora = (12, 22)
tLaCoruna = (3, 25)
tSantiago = (3, 22)
tOviendo = (7, 28)
tPamplona = (18, 35)
tBilbao = (14, 35)
tOporto = (6, 18)
tLisbon = (11, 10)
tCoimbra = (10, 16)
tChaves = (7, 22)

# christian regions
tLeonList =		[	tSantiago,
				tLaCoruna,
				tOviendo,
				tLeon,
				tZamora		]
tCastilleList =		[	tBurgos,
				tSantander,
				tSoria,
				tBilbao		]
tBarcelonaList =	[	tBarcelona,
				tPamplona,
				tTortosa	]
tPortgualList =		[	tOporto,
				tCoimbra,
				tChaves		]
tGasconyList =		[	tBayonne,
				tPau		]

# moorish regions
tBadajozList =		[	tBadajoz,
				tLisbon,
				tLagos		]
tSevillaList =		[	tSevilla,
				tCadiz,
				tMalaga		]
tToledoList =		[	tToledo,
				tMadrid,
				tValladolid,
				tSalamanca	]
tGranadaList =		[	tGranada,
				tCordoba,
				tCartagena	]
tValenciaList =		[	tValencia,
				tMurcia,
				tPalma		]
tZaragozaList =		[	tZaragossa,
				tLerida		]

# african regions algiers
tFezList =		[	tFez,
				tRibat,
				tTangier,
				tTlemcen,
				tMelilla	]
tAlgiersList =		[	tAlgiers,
				tOran,
				tTahert,
				tBiskra,
				tBougie		]

# misc coords
tSiegeofGrausInvasion = (23, 33)
tReconquestofToledoMadrid = (19, 26)
tReconquestofToledoOne = (19, 22)
tReconquestofToledoTwo = (19, 23)
tReconquestofToledoThree = (20, 23)
tReconquestofToledoFour = (21, 23)
tSiegeofValenciaOne = (27, 32)
tSiegeofValenciaTwo = (28, 32)
tSiegeofValenciaThree = (27, 31)
tSiegeofValenciaFour = (27, 30)
tSiegeofValenciaFive = (28, 30)
tSiegeofLisbonOne = (10, 11)
tSiegeofLisbonTwo = (11, 11)
tSiegeofLisbonThree = (12, 11)
tSiegeofLisbonFour = (10, 10)
tSiegeofLisbonFive = (12, 10)
tSiegeofLisbonSix = (11, 9)

class recon:

	def gamestart(self):

		humanplayerid = 0

		# loop through each player modified from american revolution
		for iPlayer in range(gc.getMAX_PLAYERS()):

			if (iPlayer == 18):
				continue

			# make player event dictionary
			evd =	{	'bEventThisTurn': False,
					'bTaifaKingdoms': False,
					'bCrusades': False,
					'bCrusadesFirst': False,
					'bSiegeofGraus': False,
					'iSiegeofGrausCount': 5,
					'bSiegeofGrausPresent': False,
					'bSiegeofGrausFail': False,
					'bSiegeofGrausEarlyLoss': False,
					'bReconquestofToledo': False,
					'iReconquestofToledoCount': 10,
					'bReconquestofToledoPresent': False,
					'bReconquestofToledoFail': False,
					'bReconquestofToledoEarlyLoss': False,
					'bSiegeofValencia': False,
					'iSiegeofValenciaCount': 5,
					'bSiegeofValenciaPresent': False,
					'bSiegeofValenciaFail': False,
					'bSiegeofValenciaEarlyLoss': False,
					'bSiegeofLisbon': False,
					'iSiegeofLisbonCount': 5,
					'bSiegeofLisbonPresent': False,
					'bSiegeofLisbonFail': False,
					'bSiegeofLisbonEarlyLoss': False
				}
			gc.getPlayer(iPlayer).setScriptData( pickle.dumps(evd) )	

			# scenario start pop up for player
			player = gc.getPlayer(iPlayer)
			if (player.isAlive() and player.isHuman()):
				humanplayerid = iPlayer
			# do pop up

		# make game event dictionary
		gevd = {	'iHumanPlayerID': humanplayerid,
				'iCurrentGameTurn': 0,
				'iEventFlagCrusades': 0,
				'iEventFlagTaifaKingdoms': 0,
				'iSiegeofGrausYear': 15 + self.getRand(8),
				'bSiegeofGrausCount': false,
				'iSiegeofGrausHelpCount': 0,
				'bSiegeofGrausOver': false,
				'iReconquestofToledoYear': 34 + self.getRand(8),
				'iReconquestofToledoStep': 0,
				'bReconquestofToledoCount': false,
				'iReconquestofToledoHelpCount': 0,
				'bReconquestofToledoOver': false,
				'iSiegeofValenciaYear': 47 + self.getRand(8),
				'bSiegeofValenciaCount': false,
				'iSiegeofValenciaHelpCount': 0,
				'bSiegeofValenciaOver': false,
				'iSiegeofLisbonYear': 82 + self.getRand(10),
				'bSiegeofLisbonCount': false,
				'iSiegeofLisbonHelpCount': 0,
				'bSiegeofLisbonOver': false,
			}

		gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )


	def tech(self, iTechType, iTeam, iPlayer, bAnnounce):

		# was getting error at start of game. was it checking barbs?
		if (iPlayer not in tAllTeams):
			CyInterface().addImmediateMessage('not in list: '+str(iPlayer),"")
			return

		# Taifa Kingdoms
		if (iTechType == iTechTaifaKingdoms):

			# only muslim civ can get this
			if (iPlayer != iAlmohad):
				return

			evd = pickle.loads( gc.getPlayer(iPlayer).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bTaifaKingdoms'] = True
			gc.getPlayer(iPlayer).setScriptData( pickle.dumps(evd) )

		# Crusades
		elif (iTechType == iTechCrusades):

			# non christian civ can't get this
			if (iPlayer == iAlmohad):
				return

			evd = pickle.loads( gc.getPlayer(iPlayer).getScriptData() )
			gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
			
			evd['bEventThisTurn'] = True
			evd['bCrusades'] = True

			# is this the first crusade?
			if (gevd['iEventFlagCrusades'] == 0):
				evd['bCrusadesFirst'] = True
				gevd['iEventFlagCrusades'] = 1

			gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
			gc.getPlayer(iPlayer).setScriptData( pickle.dumps(evd) )

	# from desert war
	def cityconquest(self, iOwner, city, iConqueror ):

		# load game event dictionary
		gevd = pickle.loads( gc.getPlayer(18).getScriptData() )

		# if coimbra gets conquered before siegeoflisbon
		if (gevd['iCurrentGameTurn'] < (gevd['iSiegeofLisbonYear'] - 5) and self.equals(city, self.getCity(tCoimbra)) and iConqueror == iAlmohad):
			gevd['bSiegeofLisbonOver'] = true
			gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
		# if it gets liberated
		elif (gevd['iCurrentGameTurn'] < (gevd['iSiegeofLisbonYear'] - 5) and self.equals(city, self.getCity(tCoimbra)) and iConqueror != iAlmohad):
			gevd['bSiegeofLisbonOver'] = false
			gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )

		# if lisbon is conquered early
		if (gevd['iCurrentGameTurn'] < (gevd['iSiegeofLisbonYear']) and self.equals(city, self.getCity(tLisbon)) and iConqueror != iAlmohad):
			evd = pickle.loads( gc.getPlayer(gevd['iHumanPlayerID']).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bSiegeofLisbon'] = True
			evd['bSiegeofLisbonEarlyLoss'] = True
			gc.getPlayer(gevd['iHumanPlayerID']).setScriptData( pickle.dumps(evd) )

		# if tortosa gets conquered before siegeofvalencia
		if (gevd['iCurrentGameTurn'] < (gevd['iSiegeofValenciaYear'] - 5) and self.equals(city, self.getCity(tTortosa)) and iConqueror == iAlmohad):
			gevd['bSiegeofValenciaOver'] = true
			gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
		# if it gets liberated
		elif (gevd['iCurrentGameTurn'] < (gevd['iSiegeofValenciaYear'] - 5) and self.equals(city, self.getCity(tTortosa)) and iConqueror != iAlmohad):
			gevd['bSiegeofValenciaOver'] = false
			gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )

		# if valencia is conquered early
		if (gevd['iCurrentGameTurn'] < (gevd['iSiegeofValenciaYear']) and self.equals(city, self.getCity(tValencia)) and iConqueror != iAlmohad):
			evd = pickle.loads( gc.getPlayer(gevd['iHumanPlayerID']).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bSiegeofValencia'] = True
			evd['bSiegeofValenciaEarlyLoss'] = True
			gc.getPlayer(gevd['iHumanPlayerID']).setScriptData( pickle.dumps(evd) )

		# if soria gets conquered before reconquestoftoledo
		if (gevd['iCurrentGameTurn'] < (gevd['iReconquestofToledoYear'] - 10) and self.equals(city, self.getCity(tSoria)) and iConqueror == iAlmohad):
			gevd['bReconquestofToledoOver'] = true
			gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
		# if it gets liberated
		elif (gevd['iCurrentGameTurn'] < (gevd['iReconquestofToledoYear'] - 10) and self.equals(city, self.getCity(tSoria)) and iConqueror != iAlmohad):
			gevd['bReconquestofToledoOver'] = false
			gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )

		# if almohad capture zaragossa early disable siegeofgraus
		if (gevd['iCurrentGameTurn'] <  gevd['iSiegeofGrausYear'] and self.equals(city, self.getCity(tZaragossa)) and iConqueror == iAlmohad):
			evd = pickle.loads( gc.getPlayer(gevd['iHumanPlayerID']).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bSiegeofGraus'] = True
			evd['bSiegeofGrausEarlyLoss'] = True
			gc.getPlayer(gevd['iHumanPlayerID']).setScriptData( pickle.dumps(evd) )

		# if almohad lose toledo early disable reconquestoftoledo
		if (gevd['iCurrentGameTurn'] <  gevd['iReconquestofToledoYear'] and self.equals(city, self.getCity(tToledo)) and iConqueror != iAlmohad):
			evd = pickle.loads( gc.getPlayer(gevd['iHumanPlayerID']).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bReconquestofToledo'] = True
			evd['bReconquestofToledoEarlyLoss'] = True
			gc.getPlayer(gevd['iHumanPlayerID']).setScriptData( pickle.dumps(evd) )


	def checkunitmove(self, pUnit):

		# load game event dictionary
		gevd = pickle.loads( gc.getPlayer(18).getScriptData() )

		# get player id of unit
		player = PyPlayer(pUnit.getOwner())
		iPlayerUnitID = player.getID()

		# human unit move checks
		if (iPlayerUnitID == gevd['iHumanPlayerID']):

			evd = pickle.loads( gc.getPlayer(iPlayerUnitID).getScriptData() )
			
			# get unit coordinates
			tempxyvar = (pUnit.getX(), pUnit.getY())

			# Siegeoflisbon (lisbon siege), only counts if unit can attack (unit with strenght?)
			if (gevd['bSiegeofLisbonCount'] and pUnit.canAttack() and (tempxyvar == tSiegeofLisbonOne or \
				tempxyvar == tSiegeofLisbonTwo or tempxyvar == tSiegeofLisbonThree or \
				tempxyvar == tSiegeofLisbonFour or tempxyvar == tSiegeofLisbonFive or tempxyvar == tSiegeofLisbonSix) and \
				evd['iSiegeofLisbonCount'] >= 0):
		
				# set player event dict
				evd['bSiegeofLisbon'] = True
				evd['bSiegeofLisbonPresent'] = True
				evd['iSiegeofLisbonCount'] = 0
				evd['bEventThisTurn'] = True

				# count how many units make it
				gevd['iSiegeofLisbonHelpCount'] += 1


			# Siegeofvalencia (valencia siege), only counts if unit can attack (unit with strenght?)
			if (gevd['bSiegeofValenciaCount'] and pUnit.canAttack() and (tempxyvar == tSiegeofValenciaOne or \
				tempxyvar == tSiegeofValenciaTwo or tempxyvar == tSiegeofValenciaThree or \
				tempxyvar == tSiegeofValenciaFour or tempxyvar == tSiegeofValenciaFive) and \
				evd['iSiegeofValenciaCount'] >= 0):
		
				# set player event dict
				evd['bSiegeofValencia'] = True
				evd['bSiegeofValenciaPresent'] = True
				evd['iSiegeofValenciaCount'] = 0
				evd['bEventThisTurn'] = True

				# count how many units make it
				gevd['iSiegeofValenciaHelpCount'] += 1

			# Siege of Graus, only counts if unit canattack (unit with strenght?)
			if (gevd['bSiegeofGrausCount'] and pUnit.canAttack() and tempxyvar == tZaragossa and \
				evd['iSiegeofGrausCount'] >= 0):
		
				# set player event dict
				evd['bSiegeofGraus'] = True
				evd['bSiegeofGrausPresent'] = True
				evd['iSiegeofGrausCount'] = 0
				evd['bEventThisTurn'] = True

				# count how many units make it
				gevd['iSiegeofGrausHelpCount'] += 1

			# Reconquest of Toledo step 1 (soria rally), only counts if unit canattack (unit with strenght?)
			if (gevd['bReconquestofToledoCount'] and pUnit.canAttack() and gevd['iReconquestofToledoStep'] == 1 and tempxyvar == tSoria and \
				evd['iReconquestofToledoCount'] >= 5):
		
				# set player event dict
				evd['bReconquestofToledo'] = True
				evd['bReconquestofToledoPresent'] = True
				evd['iReconquestofToledoCount'] = 5
				evd['bEventThisTurn'] = True
				
				gevd['iReconquestofToledoStep'] == 2

				# count how many units make it
				gevd['iReconquestofToledoHelpCount'] += 1

			# Reconquest of Toledo step 2 (toledo siege), only counts if unit can attack (unit with strenght?)
			elif (gevd['bReconquestofToledoCount'] and pUnit.canAttack() and gevd['iReconquestofToledoStep'] == 2 and \
				(tempxyvar == tReconquestofToledoOne or tempxyvar == tReconquestofToledoTwo or tempxyvar == tReconquestofToledoThree or tempxyvar == tReconquestofToledoFour) and \
				evd['iReconquestofToledoCount'] >= 0):
		
				# set player event dict
				evd['bReconquestofToledo'] = True
				evd['bReconquestofToledoPresent'] = True
				evd['iReconquestofToledoCount'] = 0
				evd['bEventThisTurn'] = True

				gevd['iReconquestofToledoStep'] == 3

				# count how many units make it
				gevd['iReconquestofToledoHelpCount'] += 1

			# save changes
			gc.getPlayer(iPlayerUnitID).setScriptData( pickle.dumps(evd) )
		
		gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )

	def begingameturn(self, iGameTurn):
	
		# load game event dictionary
		gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
		gevd['iCurrentGameTurn'] = iGameTurn
		gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )

		# 1050 is gameturn 4
		#zaragossa 1063 13 - toledo 1085 35 - valencia 1094 44 - lisbon 1147 86	
		
		# Siege of Graus within 5 turns
		if (gevd['iCurrentGameTurn'] == (gevd['iSiegeofGrausYear'] - 5) or gevd['bSiegeofGrausCount']):

			# if almohad had an early conquest, skip event countdown
			if (gevd['bSiegeofGrausOver']):
				return

			# if zaragossa at peace with almohad, delay event
			tmpcityvar = self.getCity(tZaragossa)
			tmpownerid = self.getCity(tZaragossa).getOwner()

			pAlmohad = gc.getPlayer(iAlmohad)
			ptmpteam = gc.getPlayer(tmpownerid)
			tmpteam = gc.getTeam(ptmpteam.getTeam())

			if (not tmpteam.isAtWar(pAlmohad.getTeam())):
				CyInterface().addImmediateMessage('no war!',"")
				gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
				gevd['iSiegeofGrausYear'] = gevd['iSiegeofGrausYear'] + 15
				gevd['bSiegeofGrausCount'] = false
				gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
				return

			evd = pickle.loads( gc.getPlayer(gevd['iHumanPlayerID']).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bSiegeofGraus'] = True
			gc.getPlayer(gevd['iHumanPlayerID']).setScriptData( pickle.dumps(evd) )

		if (gevd['iCurrentGameTurn'] == (gevd['iReconquestofToledoYear'] - 10) or gevd['bReconquestofToledoCount']):

			# if soria or toledo lost early, skip event countdown
			if (gevd['bReconquestofToledoOver']):
				return

			# if castille at peace with almohad, delay event
			pAlmohad = gc.getPlayer(iAlmohad)
			ptmpteam = gc.getPlayer(iCastille)
			tmpteam = gc.getTeam(ptmpteam.getTeam())

			if (not tmpteam.isAtWar(pAlmohad.getTeam())):
				CyInterface().addImmediateMessage('no war!',"")
				gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
				gevd['iReconquestofToledoYear'] = gevd['iReconquestofToledoYear'] + 15
				gevd['bReconquestofToledoCount'] = false
				gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
				return

			evd = pickle.loads( gc.getPlayer(gevd['iHumanPlayerID']).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bReconquestofToledo'] = True
			gc.getPlayer(gevd['iHumanPlayerID']).setScriptData( pickle.dumps(evd) )

		if (gevd['iCurrentGameTurn'] == (gevd['iSiegeofValenciaYear'] - 5) or gevd['bSiegeofValenciaCount']):

			# if tortosa lost early, skip event countdown
			if (gevd['bSiegeofValenciaOver']):
				return

			# if aragon at peace with almohad, delay event
			pAlmohad = gc.getPlayer(iAlmohad)
			ptmpteam = gc.getPlayer(iAragon)
			tmpteam = gc.getTeam(ptmpteam.getTeam())

			if (not tmpteam.isAtWar(pAlmohad.getTeam())):
				CyInterface().addImmediateMessage('no war!',"")
				gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
				gevd['iSiegeofValenciaYear'] = gevd['iSiegeofValenciaYear'] + 15
				gevd['bSiegeofValenciaCount'] = false
				gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
				return

			evd = pickle.loads( gc.getPlayer(gevd['iHumanPlayerID']).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bSiegeofValencia'] = True
			gc.getPlayer(gevd['iHumanPlayerID']).setScriptData( pickle.dumps(evd) )

		if (gevd['iCurrentGameTurn'] == (gevd['iSiegeofLisbonYear'] - 5) or gevd['bSiegeofLisbonCount']):

			# if coimbra lost early, skip event countdown
			if (gevd['bSiegeofLisbonOver']):
				return

			# if portugal at peace with almohad, delay event
			pAlmohad = gc.getPlayer(iAlmohad)
			ptmpteam = gc.getPlayer(iPortugal)
			tmpteam = gc.getTeam(ptmpteam.getTeam())

			if (not tmpteam.isAtWar(pAlmohad.getTeam())):
				CyInterface().addImmediateMessage('no war!',"")
				gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
				gevd['iSiegeofLisbonYear'] = gevd['iSiegeofValenciaYear'] + 15
				gevd['bSiegeofLisbonCount'] = false
				gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
				return

			evd = pickle.loads( gc.getPlayer(gevd['iHumanPlayerID']).getScriptData() )
			evd['bEventThisTurn'] = True
			evd['bSiegeofLisbon'] = True
			gc.getPlayer(gevd['iHumanPlayerID']).setScriptData( pickle.dumps(evd) )

		CyInterface().addImmediateMessage('Game turn: '+str(iGameTurn),"")



	def beginplayerturn(self, iGameTurn, iPlayer):
	
		if (iPlayer == 18):
			return
	
		# get player event dict
		evd = pickle.loads( gc.getPlayer(iPlayer).getScriptData() )

		if (evd['bEventThisTurn']):
			
			# Taifa Kingdoms
			if(evd['bTaifaKingdoms'] == True):
				self.taifa(iPlayer)
				evd['bTaifaKingdoms'] = False

			# Crusades
			if(evd['bCrusades'] == True):
				self.crusades(iPlayer, evd['bCrusadesFirst'])
				evd['bCrusades'] = False

			# Siege of Graus
			if (evd['bSiegeofGraus'] == True):
				if (evd['bSiegeofGrausEarlyLoss'] and evd['iSiegeofGrausCount'] > 0):
					self.siegeofgraus(iPlayer, 4)
				elif (evd['iSiegeofGrausCount'] == 5):
					self.siegeofgraus(iPlayer, 1)
				elif (evd['iSiegeofGrausCount'] == 0):
					self.siegeofgraus(iPlayer, 2)
				elif (evd['iSiegeofGrausCount'] == -1):
					self.siegeofgraus(iPlayer, 3)

				evd['iSiegeofGrausCount'] = evd['iSiegeofGrausCount'] - 1
				evd['bSiegeofGraus'] = False

			# Reconquest of Toledo
			if (evd['bReconquestofToledo'] == True):
				if (evd['bReconquestofToledoEarlyLoss'] and evd['iReconquestofToledoCount'] > 0):
					self.reconquestoftoledo(iPlayer, 5)
				elif (evd['iReconquestofToledoCount'] == 10):
					self.reconquestoftoledo(iPlayer, 1)
				elif (evd['iReconquestofToledoCount'] == 5):
					self.reconquestoftoledo(iPlayer, 2)
				elif (evd['iReconquestofToledoCount'] == 0):
					self.reconquestoftoledo(iPlayer, 3)
				elif (evd['iReconquestofToledoCount'] == -1):
					self.reconquestoftoledo(iPlayer, 4)

				evd['iReconquestofToledoCount'] = evd['iReconquestofToledoCount'] - 1
				evd['bReconquestofToledo'] = False

			# Siege of Valencia
			if (evd['bSiegeofValencia'] == True):
				if (evd['bSiegeofValenciaEarlyLoss'] and evd['iSiegeofValenciaCount'] > 0):
					self.siegeofvalencia(iPlayer, 3)
				elif (evd['iSiegeofValenciaCount'] == 5):
					self.siegeofvalencia(iPlayer, 1)
				elif (evd['iSiegeofValenciaCount'] == 0):
					self.siegeofvalencia(iPlayer, 2)
				elif (evd['iSiegeofValenciaCount'] == -1):
					self.siegeofvalencia(iPlayer, 3)

				evd['iSiegeofValenciaCount'] = evd['iSiegeofValenciaCount'] - 1
				evd['bSiegeofValencia'] = False

			# Siege of Lisbon
			if (evd['bSiegeofLisbon'] == True):
				if (evd['bSiegeofLisbonEarlyLoss'] and evd['iSiegeofLisbonCount'] > 0):
					self.siegeoflisbon(iPlayer, 3)
				elif (evd['iSiegeofLisbonCount'] == 5):
					self.siegeoflisbon(iPlayer, 1)
				elif (evd['iSiegeofLisbonCount'] == 0):
					self.siegeoflisbon(iPlayer, 2)
				elif (evd['iSiegeofLisbonCount'] == -1):
					self.siegeoflisbon(iPlayer, 3)

				evd['iSiegeofLisbonCount'] = evd['iSiegeofLisbonCount'] - 1
				evd['bSiegeofLisbon'] = False
				
			evd['bEventThisTurn'] = False
			gc.getPlayer(iPlayer).setScriptData( pickle.dumps(evd) )

		return

	def siegeoflisbon(self, iPlayer, iStage):

		tmpcityvar = self.getCity(tLisbon)
		iLisbonOwnerID = self.getCity(tLisbon).getOwner()
		
		# load event dictionaries
		gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
		evd = pickle.loads( gc.getPlayer(iPlayer).getScriptData() )

		# stage one: pop up to player
		if (iStage == 1):

			# flag the event countdown
			gevd['bSiegeofLisbonCount'] = True

			# not for almohad
			if (gevd['iHumanPlayerID'] != iAlmohad):
				popup = PyPopup.PyPopup()
				popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_ONE_EVENT_TITLE", ()) )
				popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_ONE_EVENT", ()) )
				popup.launch()

			tmpstring = "Lisbon must fall!"
			CyInterface().addImmediateMessage(tmpstring,"")

		# stage two: set up new units
		elif (iStage == 2):
			
			# clear plot and place portugal-AI army

			if (gevd['iHumanPlayerID'] != iPortugal):
				self.checkplotforenemy(iAragon, tSiegeofLisbonOne[0], tSiegeofLisbonOne[1])
				pPlot = CyMap().plot(tSiegeofLisbonOne[0], tSiegeofLisbonOne[1])

				tmpunitlist = []
				tmpunitlist += self.makeUnit(iMilitia, iPortugal, pPlot, 2)
				tmpunitlist += self.makeUnit(iAxeman, iPortugal, pPlot, 1)
				tmpunitlist += self.makeUnit(iArcher, iPortugal, pPlot, 3)
				tmpunitlist += self.makeUnit(iChristianHorse, iPortugal, pPlot, 2)
				tmpunitlist += self.makeUnit(iSwordsman, iPortugal, pPlot, 3)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(5)

			CyInterface().addImmediateMessage(str(gevd['iSiegeofLisbonHelpCount'])+' player units made it to the siege of Lisbon!',"")

		# stage three: aftermath
		elif (iStage == 3):
		
			# almohad was not able to defend city
			if (iLisbonOwnerID != iAlmohad):
				# player participated
				if (evd['bSiegeofLisbonPresent'] == true):
				
					tmpunitlist = []
					tmpcityname = ""

					# make a temp list of core christian cities
					tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList
					
					# find the FIRST city of this player (could be random with a list/index?)
					for tCoords in tCrusadesCandidates:

						tmpcityvar = self.getCity(tCoords)
						iPlayervar = tmpcityvar.getOwner()

						# if city belongs to player
						if (iPlayervar == iPlayer):
			
							# get the city name for message
							tmpcityname = tmpcityvar.getName()

							# 100 gold
							tmpamount = 100
							gc.getPlayer(iPlayer).changeGold(tmpamount)

							# create 1 conquistador
							tmpunitlist = self.makeUnit(iConquistador, iPlayer, tmpcityvar.plot(), 1)

							CyInterface().addImmediateMessage('Reward unit created in '+tmpcityname+'.',"")

							# and exit city loop
							break

					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_TWO_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_TWO_EVENT", ()) )
					popup.launch()


				# player did not participate
				elif (evd['bSiegeofLisbonPresent'] == false):
					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_THREE_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_THREE_EVENT", ()) )
					popup.launch()

			# almohad was able to defend city
			elif (iLisbonOwnerID == iAlmohad):

				# create two free defending skirmishers
				tmpunitlist = self.makeUnit(iSkirmisher, iAlmohad, tmpcityvar.plot(), 2)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(10)

				# player participated
				if (evd['bSiegeofLisbonPresent'] == true):
				
					tmpunitlist = []
					tmpcityname = ""

					# make a temp list of core christian cities
					tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList
					
					# find the FIRST city of this player (could be random with a list/index?)
					for tCoords in tCrusadesCandidates:

						tmpcityvar = self.getCity(tCoords)
						iPlayervar = tmpcityvar.getOwner()

						# if city belongs to player
						if (iPlayervar == iPlayer):
			
							# get the city name for message
							tmpcityname = tmpcityvar.getName()

							# create 2 archers
							tmpunitlist = self.makeUnit(iArcher, iPlayer, tmpcityvar.plot(), 2)

							CyInterface().addImmediateMessage('Survivor units created in '+tmpcityname+'.',"")

							# and exit city loop
							break

					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_FOUR_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_FOUR_EVENT", ()) )
					popup.launch()


				# player did not participate
				elif (evd['bSiegeofLisbonPresent'] == false):
					evd['bSiegeofLisbonFail'] = true
					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_FIVE_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_LISBON_FIVE_EVENT", ()) )
					popup.launch()

			# siege of graus countdown finished
			gevd['bSiegeofLisbonCount'] = False
			# this event is done
			gevd['bSiegeofLisbonOver'] = true

		# save event dictionaries
		gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
		gc.getPlayer(iPlayer).setScriptData( pickle.dumps(evd) )

	def siegeofvalencia(self, iPlayer, iStage):

		tmpcityvar = self.getCity(tValencia)
		iValenciaOwnerID = self.getCity(tValencia).getOwner()
		
		# load event dictionaries
		gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
		evd = pickle.loads( gc.getPlayer(iPlayer).getScriptData() )

		# stage one: pop up to player
		if (iStage == 1):

			# flag the event countdown
			gevd['bSiegeofValenciaCount'] = True

			# not for almohad
			if (gevd['iHumanPlayerID'] != iAlmohad):
				popup = PyPopup.PyPopup()
				popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_ONE_EVENT_TITLE", ()) )
				popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_ONE_EVENT", ()) )
				popup.launch()

			tmpstring = "El Cid Campeador"
			CyInterface().addImmediateMessage(tmpstring,"")

		# stage two: set up new units
		elif (iStage == 2):
			
			# clear plot and place aragon-AI army

			if (gevd['iHumanPlayerID'] != iAragon):
				self.checkplotforenemy(iAragon, tSiegeofValenciaThree[0], tSiegeofValenciaThree[1])
				pPlot = CyMap().plot(tSiegeofValenciaThree[0], tSiegeofValenciaThree[1])

				tmpunitlist = []
				tmpunitlist += self.makeUnit(iMilitia, iAragon, pPlot, 2)
				tmpunitlist += self.makeUnit(iAxeman, iAragon, pPlot, 1)
				tmpunitlist += self.makeUnit(iArcher, iAragon, pPlot, 3)
				tmpunitlist += self.makeUnit(iChristianHorse, iAragon, pPlot, 3)
				tmpunitlist += self.makeUnit(iSwordsman, iAragon, pPlot, 4)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(5)

			CyInterface().addImmediateMessage(str(gevd['iSiegeofValenciaHelpCount'])+' player units made it to the siege of Valencia!',"")

		# stage three: aftermath
		elif (iStage == 3):
		
			# almohad was not able to defend city
			if (iValenciaOwnerID != iAlmohad):
				# player participated
				if (evd['bSiegeofValenciaPresent'] == true):
				
					tmpunitlist = []
					tmpcityname = ""

					# make a temp list of core christian cities
					tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList
					
					# find the FIRST city of this player (could be random with a list/index?)
					for tCoords in tCrusadesCandidates:

						tmpcityvar = self.getCity(tCoords)
						iPlayervar = tmpcityvar.getOwner()

						# if city belongs to player
						if (iPlayervar == iPlayer):
			
							# get the city name for message
							tmpcityname = tmpcityvar.getName()

							# 100 gold
							tmpamount = 100
							gc.getPlayer(iPlayer).changeGold(tmpamount)

							# create 1 conquistador
							tmpunitlist = self.makeUnit(iConquistador, iPlayer, tmpcityvar.plot(), 1)

							CyInterface().addImmediateMessage('Reward unit created in '+tmpcityname+'.',"")

							# and exit city loop
							break

					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_TWO_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_TWO_EVENT", ()) )
					popup.launch()


				# player did not participate
				elif (evd['bSiegeofValenciaPresent'] == false):
					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_THREE_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_THREE_EVENT", ()) )
					popup.launch()

			# almohad was able to defend city
			elif (iValenciaOwnerID == iAlmohad):

				# create two free defending skirmishers
				tmpunitlist = self.makeUnit(iSkirmisher, iAlmohad, tmpcityvar.plot(), 2)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(10)

				# player participated
				if (evd['bSiegeofValenciaPresent'] == true):
				
					tmpunitlist = []
					tmpcityname = ""

					# make a temp list of core christian cities
					tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList
					
					# find the FIRST city of this player (could be random with a list/index?)
					for tCoords in tCrusadesCandidates:

						tmpcityvar = self.getCity(tCoords)
						iPlayervar = tmpcityvar.getOwner()

						# if city belongs to player
						if (iPlayervar == iPlayer):
			
							# get the city name for message
							tmpcityname = tmpcityvar.getName()

							# create 2 archers
							tmpunitlist = self.makeUnit(iArcher, iPlayer, tmpcityvar.plot(), 2)

							CyInterface().addImmediateMessage('Survivor units created in '+tmpcityname+'.',"")

							# and exit city loop
							break

					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_FOUR_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_FOUR_EVENT", ()) )
					popup.launch()


				# player did not participate
				elif (evd['bSiegeofValenciaPresent'] == false):
					evd['bSiegeofValenciaFail'] = true
					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_FIVE_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_VALENCIA_FIVE_EVENT", ()) )
					popup.launch()

			# siege of graus countdown finished
			gevd['bSiegeofValenciaCount'] = False
			# this event is done
			gevd['bSiegeofValenciaOver'] = true

		# save event dictionaries
		gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
		gc.getPlayer(iPlayer).setScriptData( pickle.dumps(evd) )



	def reconquestoftoledo(self, iPlayer, iStage):

		tmpcityvar = self.getCity(tToledo)
		iToledoOwnerID = self.getCity(tToledo).getOwner()
		
		# load event dictionaries
		gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
		evd = pickle.loads( gc.getPlayer(iPlayer).getScriptData() )

		# stage one: pop up to player
		if (iStage == 1):

			# flag the event countdown
			gevd['bReconquestofToledoCount'] = True

			# set to first step (go to soria)
			gevd['iReconquestofToledoStep'] = 1

			# not for almohad
			if (gevd['iHumanPlayerID'] != iAlmohad):
				popup = PyPopup.PyPopup()
				popup.setHeaderString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_ONE_EVENT_TITLE", ()) )
				popup.setBodyString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_ONE_EVENT", ()) )
				popup.launch()

			tmpstring = "A Grand Campaign..."
			CyInterface().addImmediateMessage(tmpstring,"")

		# stage two: another pop up to player
		elif (iStage == 2):

			# set to second step (attack toledo)
			gevd['iReconquestofToledoStep'] = 2

			CyInterface().addImmediateMessage(str(gevd['iReconquestofToledoHelpCount'])+' player units made it to Soria!',"")

			# if soria is player owned
			tmpsoriavar = self.getCity(tSoria)
			iSoriaOwnerID = self.getCity(tSoria).getOwner()

			# check if player sent help, and pop up not for almohad player
			if (((iSoriaOwnerID == gevd['iHumanPlayerID']) or gevd['iReconquestofToledoHelpCount'] != 0) and gevd['iHumanPlayerID'] != iAlmohad):
			
				# give player free swordsman in soria
				freesoriaunit = self.makeUnit(iSwordsman, gevd['iHumanPlayerID'], tmpsoriavar.plot(), 1)

				# if madrid is in the way, create AI-castille force near it
				tmpmadridvar = self.getCity(tMadrid)
				iMadridOwnerID = self.getCity(tMadrid).getOwner()
				
				if (iMadridOwnerID == iAlmohad and gevd['iHumanPlayerID'] != iCastille):
					self.checkplotforenemy(iCastille, tReconquestofToledoMadrid[0], tReconquestofToledoMadrid[1])
					pPlot = CyMap().plot(tReconquestofToledoMadrid[0], tReconquestofToledoMadrid[1])
					tmpunitlist = []
					tmpunitlist += self.makeUnit(iSwordsman, iCastille, pPlot, 3)
					tmpunitlist += self.makeUnit(iAxeman, iCastille, pPlot, 1)
					tmpunitlist += self.makeUnit(iArcher, iCastille, pPlot, 2)
					for i in range(len(tmpunitlist)):
						tmpunitlist[i].setUnitAIType(5)

				popup = PyPopup.PyPopup()
				popup.setHeaderString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_TWO_EVENT_TITLE", ()) )
				popup.setBodyString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_TWO_EVENT", ()) )
				popup.launch()

			elif (gevd['iReconquestofToledoHelpCount'] == 0 and gevd['iHumanPlayerID'] != iAlmohad):
				popup = PyPopup.PyPopup()
				popup.setHeaderString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_THREE_EVENT_TITLE", ()) )
				popup.setBodyString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_THREE_EVENT", ()) )
				popup.launch()

			evd['bReconquestofToledoPresent'] = False
			gevd['iReconquestofToledoHelpCount'] = 0

			tmpstring = "Onwards to Toledo!"
			CyInterface().addImmediateMessage(tmpstring,"")


		# stage three: set up new units
		elif (iStage == 3):

			# create castille-AI siege force
			if (gevd['iHumanPlayerID'] != iCastille):

				# clear plot and place castille army
				self.checkplotforenemy(iCastille, tReconquestofToledoOne[0], tReconquestofToledoOne[1])
				pPlot = CyMap().plot(tReconquestofToledoOne[0], tReconquestofToledoOne[1])
				tmpunitlist = []
				tmpunitlist += self.makeUnit(iSwordsman, iCastille, pPlot, 4)
				tmpunitlist += self.makeUnit(iAxeman, iCastille, pPlot, 1)
				tmpunitlist += self.makeUnit(iArcher, iCastille, pPlot, 2)
				tmpunitlist += self.makeUnit(iChristianHorse, iCastille, pPlot, 2)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(5)

			CyInterface().addImmediateMessage(str(gevd['iReconquestofToledoHelpCount'])+' player units made it to the siege of Toledo!',"")

		# stage four: aftermath
		elif (iStage == 4):

			# rise of almoravid
			tAfricaCandidates = tFezList + tAlgiersList
			# loop through the cities ...
			for tCoords in tAfricaCandidates:
				tmpcityvar = self.getCity(tCoords)
				iPlayervar = tmpcityvar.getOwner()

				# if the city belongs to almohad ...
				if (iPlayervar == iAlmohad):
					# create a horseman
					tmpunitlist = self.makeUnit(iArabHorse, iAlmohad, tmpcityvar.plot(), 1)
		
			# almohad was not able to defend city
			if (iToledoOwnerID != iAlmohad):
				# player participated
				if (evd['bReconquestofToledoPresent'] == true):
				
					tmpunitlist = []
					tmpcityname = ""

					# make a temp list of core christian cities
					tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList
					
					# find the FIRST city of this player (could be random with a list/index?)
					for tCoords in tCrusadesCandidates:

						tmpcityvar = self.getCity(tCoords)
						iPlayervar = tmpcityvar.getOwner()

						# if city belongs to player
						if (iPlayervar == iPlayer):
			
							# get the city name for message
							tmpcityname = tmpcityvar.getName()

							# 100 gold
							tmpamount = 100
							gc.getPlayer(iPlayer).changeGold(tmpamount)

							# create 1 conquistador
							tmpunitlist = self.makeUnit(iConquistador, iPlayer, tmpcityvar.plot(), 1)

							CyInterface().addImmediateMessage('Reward unit created in '+tmpcityname+'.',"")

							# and exit city loop
							break

					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_FOUR_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_FOUR_EVENT", ()) )
					popup.launch()


				# player did not participate
				elif (evd['bReconquestofToledoPresent'] == false):
					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_FIVE_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_FIVE_EVENT", ()) )
					popup.launch()


			# almohad was able to defend city
			elif (iToledoOwnerID == iAlmohad):

				# create two free defending skirmishers
				tmpunitlist = self.makeUnit(iSkirmisher, iAlmohad, tmpcityvar.plot(), 2)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(10)

				# player participated
				if (evd['bReconquestofToledoPresent'] == true):
				
					tmpunitlist = []
					tmpcityname = ""

					# make a temp list of core christian cities
					tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList
					
					# find the FIRST city of this player (could be random with a list/index?)
					for tCoords in tCrusadesCandidates:

						tmpcityvar = self.getCity(tCoords)
						iPlayervar = tmpcityvar.getOwner()

						# if city belongs to player
						if (iPlayervar == iPlayer):
			
							# get the city name for message
							tmpcityname = tmpcityvar.getName()

							# create 2 archers
							tmpunitlist = self.makeUnit(iArcher, iPlayer, tmpcityvar.plot(), 2)

							CyInterface().addImmediateMessage('Survivor units created in '+tmpcityname+'.',"")

							# and exit city loop
							break

					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_SIX_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_SIX_EVENT", ()) )
					popup.launch()


				# player did not participate
				elif (evd['bReconquestofToledoPresent'] == false):
					evd['bReconquestofToledoFail'] = true
					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_SEVEN_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_SEVEN_EVENT", ()) )
					popup.launch()

			# siege of graus countdown finished
			gevd['bReconquestofToledoCount'] = False
			# this event is done
			gevd['bReconquestofToledoOver'] = true

		# stage four: toledo fell early
		elif (iStage == 5):

			# rise of almoravid
			tAfricaCandidates = tFezList + tAlgiersList
			# loop through the cities ...
			for tCoords in tAfricaCandidates:
				tmpcityvar = self.getCity(tCoords)
				iPlayervar = tmpcityvar.getOwner()

				# if the city belongs to almohad ...
				if (iPlayervar == iAlmohad):
					# create a horseman
					tmpunitlist = self.makeUnit(iArabHorse, iAlmohad, tmpcityvar.plot(), 1)

			# this event is done
			gevd['bReconquestofToledoOver'] = true	
			# siege of graus finished
			gevd['bReconquestofToledoCount'] = False

			# create three free defending archers
			tmpcityvar = self.getCity(tToledo)
			tmpunitlist = self.makeUnit(iArcher, iToledoOwnerID, tmpcityvar.plot(), 3)
			for i in range(len(tmpunitlist)):
				tmpunitlist[i].setUnitAIType(10)

			popup = PyPopup.PyPopup()
			popup.setHeaderString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_EIGHT_EVENT_TITLE", ()) )
			popup.setBodyString( localText.getText("TXT_KEY_RECONQUEST_OF_TOLEDO_EIGHT_EVENT", ()) )
			popup.launch()		

		# save event dictionaries
		gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
		gc.getPlayer(iPlayer).setScriptData( pickle.dumps(evd) )



	def siegeofgraus(self, iPlayer, iStage):

		tmpcityvar = self.getCity(tZaragossa)
		iZaragossaOwnerID = self.getCity(tZaragossa).getOwner()
		
		# load event dictionaries
		gevd = pickle.loads( gc.getPlayer(18).getScriptData() )
		evd = pickle.loads( gc.getPlayer(iPlayer).getScriptData() )

		# stage one: pop up to player
		if (iStage == 1):

			# flag the event countdown
			gevd['bSiegeofGrausCount'] = True

			# not for almohad
			if (gevd['iHumanPlayerID'] != iAlmohad):
				popup = PyPopup.PyPopup()
				popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_ONE_EVENT_TITLE", ()) )
				popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_ONE_EVENT", ()) )
				popup.launch()

			tmpstring = "A battle looms over Zaragossa..."
			CyInterface().addImmediateMessage(tmpstring,"")

		# stage two: set up new units
		elif (iStage == 2):
			
			# give AI owner of zaragossa 2 archer and set to city defense ai
			if (gevd['iHumanPlayerID'] != iZaragossaOwnerID):
				tmpunitlist = self.makeUnit(iArcher, iZaragossaOwnerID, tmpcityvar.plot(), 2)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(10)

			# human is owner of zaragossa and present
			elif (gevd['iHumanPlayerID'] == iZaragossaOwnerID):
				evd['bSiegeofGrausPresent'] = True

			# clear plot and place almohad army

			#clearedplot = self.checkplotforenemy(iAlmohad, tSiegeofGrausInvasion[0], tSiegeofGrausInvasion[1], true, true, 0)
			self.checkplotforenemy(iAlmohad, tSiegeofGrausInvasion[0], tSiegeofGrausInvasion[1])
			pPlot = CyMap().plot(tSiegeofGrausInvasion[0], tSiegeofGrausInvasion[1])

			tmpunitlist = []
			tmpunitlist += self.makeUnit(iMilitia, iAlmohad, pPlot, 1)
			tmpunitlist += self.makeUnit(iAxeman, iAlmohad, pPlot, 1)
			tmpunitlist += self.makeUnit(iSkirmisher, iAlmohad, pPlot, 3)
			tmpunitlist += self.makeUnit(iArabHorse, iAlmohad, pPlot, 2)
			tmpunitlist += self.makeUnit(iCamelArcher, iAlmohad, pPlot, 1)
			for i in range(len(tmpunitlist)):
				tmpunitlist[i].setUnitAIType(5)

			CyInterface().addImmediateMessage(str(gevd['iSiegeofGrausHelpCount'])+' player units made it to the aid of Zaragossa!',"")

		# stage three: aftermath
		elif (iStage == 3):
		
			# almohad was not able to take city
			if (iZaragossaOwnerID != iAlmohad):
				# player participated
				if (evd['bSiegeofGrausPresent'] == true):
				
					tmpunitlist = []
					tmpcityname = ""

					# give AI owner of zaragossa 2 archer and set to city defense ai
					if (gevd['iHumanPlayerID'] != iZaragossaOwnerID):
						tmpunitlist = self.makeUnit(iArcher, iZaragossaOwnerID, tmpcityvar.plot(), 2)
						for i in range(len(tmpunitlist)):
							tmpunitlist[i].setUnitAIType(10)

					# make a temp list of core christian cities
					tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList
					
					# find the FIRST city of this player (could be random with a list/index?)
					for tCoords in tCrusadesCandidates:

						tmpcityvar = self.getCity(tCoords)
						iPlayervar = tmpcityvar.getOwner()

						# if city belongs to player
						if (iPlayervar == iPlayer):
			
							# get the city name for message
							tmpcityname = tmpcityvar.getName()

							# 100 gold
							tmpamount = 100
							gc.getPlayer(iPlayer).changeGold(tmpamount)

							# create 1 conquistador
							tmpunitlist = self.makeUnit(iConquistador, iPlayer, tmpcityvar.plot(), 1)

							CyInterface().addImmediateMessage('Reward unit created in '+tmpcityname+'.',"")

							# and exit city loop
							break

					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_TWO_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_TWO_EVENT", ()) )
					popup.launch()


				# player did not participate
				elif (evd['bSiegeofGrausPresent'] == false):
					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_THREE_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_THREE_EVENT", ()) )
					popup.launch()

			# almohad was able to take city
			elif (iZaragossaOwnerID == iAlmohad):

				# reinforce AIs
				self.reinforcenavarreai()
				self.reinforcearagonai()

				# create two free defending skirmishers
				tmpunitlist = self.makeUnit(iSkirmisher, iAlmohad, tmpcityvar.plot(), 2)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(10)

				# player participated
				if (evd['bSiegeofGrausPresent'] == true):
				
					tmpunitlist = []
					tmpcityname = ""

					# make a temp list of core christian cities
					tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList
					
					# find the FIRST city of this player (could be random with a list/index?)
					for tCoords in tCrusadesCandidates:

						tmpcityvar = self.getCity(tCoords)
						iPlayervar = tmpcityvar.getOwner()

						# if city belongs to player
						if (iPlayervar == iPlayer):
			
							# get the city name for message
							tmpcityname = tmpcityvar.getName()

							# create 2 archers
							tmpunitlist = self.makeUnit(iArcher, iPlayer, tmpcityvar.plot(), 2)

							CyInterface().addImmediateMessage('Survivor units created in '+tmpcityname+'.',"")

							# and exit city loop
							break

					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_FOUR_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_FOUR_EVENT", ()) )
					popup.launch()


				# player did not participate
				elif (evd['bSiegeofGrausPresent'] == false):
					evd['bSiegeofGrausFail'] = true
					popup = PyPopup.PyPopup()
					popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_FIVE_EVENT_TITLE", ()) )
					popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_FIVE_EVENT", ()) )
					popup.launch()

			# siege of graus countdown finished
			gevd['bSiegeofGrausCount'] = False
			# this event is done
			gevd['bSiegeofGrausOver'] = true

		# stage four: almohad took city early
		elif (iStage == 4):

			# this event is done
			gevd['bSiegeofGrausOver'] = true	
			# siege of graus finished
			gevd['bSiegeofGrausCount'] = False

			# create three free defending skirmishers
			tmpunitlist = self.makeUnit(iSkirmisher, iAlmohad, tmpcityvar.plot(), 3)
			for i in range(len(tmpunitlist)):
				tmpunitlist[i].setUnitAIType(10)

			popup = PyPopup.PyPopup()
			popup.setHeaderString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_SIX_EVENT_TITLE", ()) )
			popup.setBodyString( localText.getText("TXT_KEY_SIEGE_OF_GRAUSS_SIX_EVENT", ()) )
			popup.launch()		

		# save event dictionaries
		gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )
		gc.getPlayer(iPlayer).setScriptData( pickle.dumps(evd) )


	def taifa(self, iPlayer):

		# load events dictionary
		gevd = pickle.loads( gc.getPlayer(18).getScriptData() )

		if (gevd['iEventFlagTaifaKingdoms'] == 1):
			return

		# make a temp list of muslim influence cities 
		tTaifaCandidates = tBadajozList + tSevillaList + tToledoList + tGranadaList + tValenciaList + tZaragozaList

		# loop through the cities ...
		for tCoords in tTaifaCandidates:
			tmpcityvar = self.getCity(tCoords)
			iPlayervar = tmpcityvar.getOwner()

			# if the city belongs to almohad ...
			if (iPlayervar == iAlmohad):

				# create a skirmisher and set city defense AI (if setUnitAIType works?)
				tmpunitlist = self.makeUnit(iSkirmisher, iAlmohad, tmpcityvar.plot(), 1)
				for i in range(len(tmpunitlist)):
					tmpunitlist[i].setUnitAIType(10)

		# set and save the event flag
		gevd['iEventFlagTaifaKingdoms'] = 1
		gc.getPlayer(18).setScriptData( pickle.dumps(gevd) )

		popup = PyPopup.PyPopup()
		popup.setHeaderString( localText.getText("TXT_KEY_TAIFA_KINGDOMS_EVENT_TITLE", ()) )
		popup.setBodyString( localText.getText("TXT_KEY_TAIFA_KINGDOMS_EVENT", ()) )
		popup.launch()

		tmpstring = "The Almohad have entered the Taifa Kingdoms period."
		CyInterface().addImmediateMessage(tmpstring,"")


	def crusades(self, iPlayer, bIsFirst):

		# make a temp list of core christian cities
		tCrusadesCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList

		# unit list and city name
		tmpunitlist = []
		tmpcityname = ""

		# find the FIRST city of this player (could be random with a list/index?)
		for tCoords in tCrusadesCandidates:

			tmpcityvar = self.getCity(tCoords)
			iPlayervar = tmpcityvar.getOwner()

			# if city belongs to player
			if (iPlayervar == iPlayer):
			
				# get the city name for message
				tmpcityname = tmpcityvar.getName()

				# for the first civ to discover
				if (bIsFirst == True):
				
					# 350 gold (enough to upgrade the 2 militias)
					tmpamount = 350
					gc.getPlayer(iPlayer).changeGold(tmpamount)

					# create 2 conquistador 1 crossbow 1 pikeman
					tmpunitlist += self.makeUnit(iConquistador, iPlayer, tmpcityvar.plot(), 2)
					tmpunitlist += self.makeUnit(iCrossbowman, iPlayer, tmpcityvar.plot(), 1)
					tmpunitlist += self.makeUnit(iPikeman, iPlayer, tmpcityvar.plot(), 1)

				# create 2 militia 1 pike 1 horse
				tmpunitlist += self.makeUnit(iMilitia, iPlayer, tmpcityvar.plot(), 2)
				tmpunitlist += self.makeUnit(iPikeman, iPlayer, tmpcityvar.plot(), 1)
				tmpunitlist += self.makeUnit(iChristianHorse, iPlayer, tmpcityvar.plot(), 1)

				# and exit city loop				
				break
				
		# set attack AI for new units (if setUnitAIType works?)
		for i in range(len(tmpunitlist)):
			tmpunitlist[i].setUnitAIType(4)

		if (bIsFirst == True):
			popup = PyPopup.PyPopup()
			popup.setHeaderString( localText.getText("TXT_KEY_CRUSADES_EVENT_TITLE", ()) )
			popup.setBodyString( localText.getText("TXT_KEY_CRUSADES_EVENT", ()) )
			popup.launch()

		tmpcivadj = gc.getPlayer(iPlayer).getCivilizationAdjective(2)
		tmpstring = "A crusade has been called in the " + tmpcivadj + " city of " + tmpcityname + "."
		CyInterface().addImmediateMessage(tmpstring,"")


## other functions

	# from desert war
	def makeUnit(self, iUnit, iPlayer, plot, iNum ):
		"""Makes iNum units for player iPlayer of the type iUnit at plot;
		returns a list of the created units."""
		unitList = []
		for i in range(iNum):
			player = gc.getPlayer(iPlayer)
			unit = player.initUnit(iUnit, plot.getX(), plot.getY(), UnitAITypes.NO_UNITAI)
			unitList.append(unit)
		return unitList

	# from desert war
	def getCity(self, tCoords ):
		"""Returns the city at coordinates tCoords."""
		return gc.getMap().plot( tCoords[0], tCoords[1] ).getPlotCity()

	# from desert war
	def equals( self, city1, city2 ):
		"""Returns True if city1 is the same city as city2."""
		return ( city1.getX() == city2.getX() and city1.getY() == city2.getY() )

	# from american revolution
	def getRand(self, iNum):
		return CyGame().getSorenRandNum(iNum, "Reconquista")

	# from american revolution added impassable test
	# playerid, city.getX(), city.getY(), landunit?, includecenterplot?, tilerange
	def findUnitPlacementPlot(self, iPlayerID, iPlotX, iPlotY, bLand, bIncludePlot, iRange):

		aTHEPlot = []
		aiPossiblePlots = []
		iNumPossiblePlots = 0
		aiTempPlotHolder = []

		pThisPlayer = gc.getPlayer(iPlayerID)
		pThisTeam = gc.getTeam(pThisPlayer.getTeam())

		# Loop through plots in usable range
		for iXLoop in range(iPlotX - iRange, iPlotX + iRange):
			for iYLoop in range(iPlotY - iRange, iPlotY + iRange):

				# Map bounds
				if (iXLoop >= 0 and iXLoop < CyMap().getGridWidth() and iYLoop >= 0 and iYLoop < CyMap().getGridHeight()):

					# Check to see if center plot should be excluded
					if (bIncludePlot or (not bIncludePlot and (iXLoop != iPlotX) and (iYLoop != iPlotY))):
						
						# Don't include enemy city plots!
						pPlot = CyMap().plot(iXLoop, iYLoop)
						if (pPlot.isEnemyCity(pThisPlayer.getTeam()) == false):
							
							# Check whether plot type is available
							if ((bLand == true and CyMap().plot(iXLoop, iYLoop).isWater() == false and CyMap().plot(iXLoop, iYLoop).isImpassable() == false) or \
							(bLand == false and CyMap().plot(iXLoop, iYLoop).isWater() == true)):
								aiTempPlotHolder = [iXLoop, iYLoop]
								aiPossiblePlots.append(aiTempPlotHolder)
								iNumPossiblePlots += 1
					
		if (iNumPossiblePlots == 0):
			return "Oh Snap"
		
		# Now that our list of possible plots is made, we pick one of them randomly and shove aside any enemy units already there
		iChosenPlot = self.getRand(iNumPossiblePlots - 1)
		aTHEPlot = aiPossiblePlots[iChosenPlot]
		
		# Check to see if there are any other units already on this plot
		pPlot = CyMap().plot(aTHEPlot[0], aTHEPlot[1])
		
		if (pPlot.getNumUnits() > 0):
			
			bEnemiesPresent = true
			
			while(pPlot.getNumUnits() > 0 and bEnemiesPresent):
#				print("Test0")
				pLoopUnit = pPlot.getUnit(0)
				pUnitOwner = gc.getPlayer(pLoopUnit.getOwner())
				
				if (pUnitOwner):
					# Check to see if this unit belongs to a player that 'our' player is at war with
					if (pThisTeam.isAtWar(pUnitOwner.getTeam())):
						# Move this enemy unit
						self.moveUnitAside(pLoopUnit, pUnitOwner.getID())
					else:
						# If it's a friendly, don't move it!
						bEnemiesPresent = false
		
		return aTHEPlot

	# give navarre-ai some free units in case they are threathened
	def reinforcenavarreai(self):
		
		# city list
		tReturnCandidates = tBarcelonaList + tLeonList + tCastilleList + tPortgualList + tGasconyList
		for tCoords in tReturnCandidates:

			tmpcityvar = self.getCity(tCoords)
			iPlayervar = tmpcityvar.getOwner()

			# if city belongs to navarre
			if (iPlayervar == iNavarre):
				self.makeUnit(iArcher, iNavarre, tmpcityvar.plot(), 2)
				self.makeUnit(iChristianHorse, iNavarre, tmpcityvar.plot(), 1)

	# give aragon-ai some free units in case they are threathened
	def reinforcearagonai(self):
		
		# city list
		tReturnCandidates = tBarcelonaList + tLeonList + tCastilleList + tPortgualList + tGasconyList
		for tCoords in tReturnCandidates:

			tmpcityvar = self.getCity(tCoords)
			iPlayervar = tmpcityvar.getOwner()

			# if city belongs to navarre
			if (iPlayervar == iNavarre):
				self.makeUnit(iArcher, iNavarre, tmpcityvar.plot(), 1)
				self.makeUnit(iSwordsman, iNavarre, tmpcityvar.plot(), 1)

	def checkplotforenemy(self, iPlayerID, ixcord, iycord):

		pThisPlayer = gc.getPlayer(iPlayerID)
		pThisTeam = gc.getTeam(pThisPlayer.getTeam())

		# Check to see if there are any other units already on this plot
		pPlot = CyMap().plot(ixcord, iycord)

		tmpnumunits = pPlot.getNumUnits()

		if (tmpnumunits > 0):

			bEnemiesPresent = true

			while(tmpnumunits > 0):
				pLoopUnit = pPlot.getUnit(0)
				pUnitOwner = gc.getPlayer(pLoopUnit.getOwner())

				if (pUnitOwner):
					# Check to see if this unit belongs to a player that 'our' player is at war with
					if (pThisTeam.isAtWar(pUnitOwner.getTeam())):
						# Move this enemy unit
						self.moveUnitAside(pLoopUnit, pUnitOwner.getID())
						tmpnumunits = tmpnumunits - 1
					else:
						tmpnumunits = tmpnumunits - 1


	# changed from american revolution to move unit to own city
	def moveUnitAside(self, pUnit, iPlayer):

		# check all cities
		tReturnCandidates = tLeonList + tCastilleList + tBarcelonaList + tPortgualList + tGasconyList + tBadajozList + tSevillaList + tToledoList + tGranadaList + tValenciaList + tZaragozaList + tFezList + tAlgiersList

		# find the FIRST city of this player (should be closest city)
		for tCoords in tReturnCandidates:

			tmpcityvar = self.getCity(tCoords)
			iPlayervar = tmpcityvar.getOwner()

			# if city belongs to player
			if (iPlayervar == iPlayer):
				#move the unit
				pUnit.setXY(tCoords[0], tCoords[1])

				CyInterface().addImmediateMessage('Unit at x: '+str(tCoords[0])+' and y: '+str(tCoords[1])+' moved for obstructing event',"")

				break
